
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>MDSLibraries.system_utility &#8212; PhaserVoyager 0.0.1 documentation</title>
    <link rel="stylesheet" href="../../_static/sphinxdoc.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../_static/doctools.js"></script>
    <script type="text/javascript" src="../../_static/language_data.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../index.html" accesskey="U">Module code</a> &#187;</li> 
      </ul>
    </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Source code for MDSLibraries.system_utility</h1><div class="highlight"><pre>
<span></span><span class="ch">#! /usr/bin/env python</span>
<span class="c1"># -*- coding: utf-8 -*-</span>

<span class="c1"># # Python 2 and 3: easiest option</span>
<span class="kn">from</span> <span class="nn">future.standard_library</span> <span class="kn">import</span> <span class="n">install_aliases</span>
<span class="n">install_aliases</span><span class="p">()</span>

<span class="kn">import</span> <span class="nn">sys</span>
<span class="n">info_p</span> <span class="o">=</span> <span class="n">sys</span><span class="o">.</span><span class="n">version_info</span>
<span class="n">info_g</span> <span class="o">=</span> <span class="p">(</span><span class="n">sys</span><span class="o">.</span><span class="n">version</span><span class="p">)</span><span class="o">.</span><span class="n">splitlines</span><span class="p">()</span>
<span class="n">PYTHON_V</span> <span class="o">=</span> <span class="n">info_p</span><span class="o">.</span><span class="n">major</span>

<span class="kn">import</span> <span class="nn">ctypes</span>
<span class="kn">import</span> <span class="nn">inspect</span>
<span class="kn">import</span> <span class="nn">math</span>
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">platform</span>
<span class="kn">import</span> <span class="nn">signal</span>
<span class="kn">import</span> <span class="nn">subprocess</span>
<span class="kn">import</span> <span class="nn">threading</span>
<span class="kn">import</span> <span class="nn">time</span>
<span class="kn">import</span> <span class="nn">traceback</span>
<span class="kn">import</span> <span class="nn">re</span>
<span class="kn">import</span> <span class="nn">multiprocessing</span>
<span class="kn">import</span> <span class="nn">functools</span>
<span class="kn">import</span> <span class="nn">inspect</span>
<span class="kn">import</span> <span class="nn">warnings</span>
<span class="kn">import</span> <span class="nn">cProfile</span>
<span class="kn">import</span> <span class="nn">json</span>
<span class="kn">import</span> <span class="nn">requests</span>
<span class="kn">import</span> <span class="nn">socket</span>

<span class="kn">from</span> <span class="nn">urllib.parse</span> <span class="kn">import</span> <span class="n">urlparse</span><span class="p">,</span> <span class="n">urlencode</span>
<span class="kn">from</span> <span class="nn">urllib.request</span> <span class="kn">import</span> <span class="n">urlopen</span><span class="p">,</span> <span class="n">Request</span><span class="p">,</span> <span class="n">build_opener</span><span class="p">,</span> <span class="n">install_opener</span><span class="p">,</span> <span class="n">HTTPRedirectHandler</span><span class="p">,</span> <span class="n">ProxyHandler</span>
<span class="kn">from</span> <span class="nn">urllib.error</span> <span class="kn">import</span> <span class="n">HTTPError</span>

<span class="c1">#TODO: here it is where can be configured the proxy for voyager</span>
<span class="c1"># # set up authentication info</span>
<span class="c1"># authinfo = urllib.request.HTTPBasicAuthHandler()</span>
<span class="c1"># authinfo.add_password(realm=&#39;PDQ Application&#39;,</span>
<span class="c1">#                       uri=&#39;https://mahler:8092/site-updates.py&#39;,</span>
<span class="c1">#                       user=&#39;klem&#39;,</span>
<span class="c1">#                       passwd=&#39;geheim$parole&#39;)</span>
<span class="c1"># proxy_support = urllib.request.ProxyHandler({&quot;http&quot; : &quot;http://ahad-haam:3128&quot;})</span>
<span class="c1"># proxy_support = ProxyHandler({})</span>
<span class="c1">#</span>
<span class="c1"># # build a new opener that adds authentication and caching FTP handlers</span>
<span class="c1"># opener = build_opener(proxy_support)</span>
<span class="c1">#</span>
<span class="c1"># # install it</span>
<span class="c1"># install_opener(opener)</span>

<span class="c1">#NOTE: this should be done only when proxy should not be configured</span>
<span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="p">[</span><span class="s1">&#39;NO_PROXY&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="s1">&#39;*&#39;</span>


<span class="c1">#######################################################################################################</span>
<span class="c1">#                                           SUPPORT FUNC                                              #</span>
<span class="c1">#######################################################################################################</span>

<span class="n">string_types</span> <span class="o">=</span> <span class="p">(</span><span class="nb">type</span><span class="p">(</span><span class="sa">b</span><span class="s1">&#39;&#39;</span><span class="p">),</span> <span class="nb">type</span><span class="p">(</span><span class="sa">u</span><span class="s1">&#39;&#39;</span><span class="p">))</span>

<span class="n">STOP_AND_RESET</span> <span class="o">=</span> <span class="s2">&quot;STOP_AND_RESET&quot;</span>
<span class="n">STOP_NOW</span> <span class="o">=</span> <span class="s2">&quot;STOP_NOW&quot;</span>

<div class="viewcode-block" id="deprecated"><a class="viewcode-back" href="../../MDSLibraries.system_utility.html#MDSLibraries.pdb_structure.deprecated">[docs]</a><span class="k">def</span> <span class="nf">deprecated</span><span class="p">(</span><span class="n">reason</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    This is a decorator which can be used to mark functions</span>
<span class="sd">    as deprecated. It will result in a warning being emitted</span>
<span class="sd">    when the function is used.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">reason</span><span class="p">,</span> <span class="n">string_types</span><span class="p">):</span>

        <span class="c1"># The @deprecated is used with a &#39;reason&#39;.</span>
        <span class="c1">#</span>
        <span class="c1"># .. code-block:: python</span>
        <span class="c1">#</span>
        <span class="c1">#    @deprecated(&quot;please, use another function&quot;)</span>
        <span class="c1">#    def old_function(x, y):</span>
        <span class="c1">#      pass</span>

        <span class="k">def</span> <span class="nf">decorator</span><span class="p">(</span><span class="n">func1</span><span class="p">):</span>

            <span class="k">if</span> <span class="n">inspect</span><span class="o">.</span><span class="n">isclass</span><span class="p">(</span><span class="n">func1</span><span class="p">):</span>
                <span class="n">fmt1</span> <span class="o">=</span> <span class="s2">&quot;Call to deprecated class </span><span class="si">{name}</span><span class="s2"> (</span><span class="si">{reason}</span><span class="s2">).&quot;</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">fmt1</span> <span class="o">=</span> <span class="s2">&quot;Call to deprecated function </span><span class="si">{name}</span><span class="s2"> (</span><span class="si">{reason}</span><span class="s2">).&quot;</span>

            <span class="nd">@functools</span><span class="o">.</span><span class="n">wraps</span><span class="p">(</span><span class="n">func1</span><span class="p">)</span>
            <span class="k">def</span> <span class="nf">new_func1</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
                <span class="n">warnings</span><span class="o">.</span><span class="n">simplefilter</span><span class="p">(</span><span class="s1">&#39;always&#39;</span><span class="p">,</span> <span class="ne">DeprecationWarning</span><span class="p">)</span>
                <span class="n">warnings</span><span class="o">.</span><span class="n">warn</span><span class="p">(</span>
                    <span class="n">fmt1</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">name</span><span class="o">=</span><span class="n">func1</span><span class="o">.</span><span class="vm">__name__</span><span class="p">,</span> <span class="n">reason</span><span class="o">=</span><span class="n">reason</span><span class="p">),</span>
                    <span class="n">category</span><span class="o">=</span><span class="ne">DeprecationWarning</span><span class="p">,</span>
                    <span class="n">stacklevel</span><span class="o">=</span><span class="mi">2</span>
                <span class="p">)</span>
                <span class="n">warnings</span><span class="o">.</span><span class="n">simplefilter</span><span class="p">(</span><span class="s1">&#39;default&#39;</span><span class="p">,</span> <span class="ne">DeprecationWarning</span><span class="p">)</span>
                <span class="k">return</span> <span class="n">func1</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>

            <span class="k">return</span> <span class="n">new_func1</span>

        <span class="k">return</span> <span class="n">decorator</span>

    <span class="k">elif</span> <span class="n">inspect</span><span class="o">.</span><span class="n">isclass</span><span class="p">(</span><span class="n">reason</span><span class="p">)</span> <span class="ow">or</span> <span class="n">inspect</span><span class="o">.</span><span class="n">isfunction</span><span class="p">(</span><span class="n">reason</span><span class="p">):</span>

        <span class="c1"># The @deprecated is used without any &#39;reason&#39;.</span>
        <span class="c1">#</span>
        <span class="c1"># .. code-block:: python</span>
        <span class="c1">#</span>
        <span class="c1">#    @deprecated</span>
        <span class="c1">#    def old_function(x, y):</span>
        <span class="c1">#      pass</span>

        <span class="n">func2</span> <span class="o">=</span> <span class="n">reason</span>

        <span class="k">if</span> <span class="n">inspect</span><span class="o">.</span><span class="n">isclass</span><span class="p">(</span><span class="n">func2</span><span class="p">):</span>
            <span class="n">fmt2</span> <span class="o">=</span> <span class="s2">&quot;Call to deprecated class </span><span class="si">{name}</span><span class="s2">.&quot;</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">fmt2</span> <span class="o">=</span> <span class="s2">&quot;Call to deprecated function </span><span class="si">{name}</span><span class="s2">.&quot;</span>

        <span class="nd">@functools</span><span class="o">.</span><span class="n">wraps</span><span class="p">(</span><span class="n">func2</span><span class="p">)</span>
        <span class="k">def</span> <span class="nf">new_func2</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
            <span class="n">warnings</span><span class="o">.</span><span class="n">simplefilter</span><span class="p">(</span><span class="s1">&#39;always&#39;</span><span class="p">,</span> <span class="ne">DeprecationWarning</span><span class="p">)</span>
            <span class="n">warnings</span><span class="o">.</span><span class="n">warn</span><span class="p">(</span>
                <span class="n">fmt2</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">name</span><span class="o">=</span><span class="n">func2</span><span class="o">.</span><span class="vm">__name__</span><span class="p">),</span>
                <span class="n">category</span><span class="o">=</span><span class="ne">DeprecationWarning</span><span class="p">,</span>
                <span class="n">stacklevel</span><span class="o">=</span><span class="mi">2</span>
            <span class="p">)</span>
            <span class="n">warnings</span><span class="o">.</span><span class="n">simplefilter</span><span class="p">(</span><span class="s1">&#39;default&#39;</span><span class="p">,</span> <span class="ne">DeprecationWarning</span><span class="p">)</span>
            <span class="k">return</span> <span class="n">func2</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>

        <span class="k">return</span> <span class="n">new_func2</span>

    <span class="k">else</span><span class="p">:</span>
        <span class="k">raise</span> <span class="ne">TypeError</span><span class="p">(</span><span class="nb">repr</span><span class="p">(</span><span class="nb">type</span><span class="p">(</span><span class="n">reason</span><span class="p">)))</span></div>

<div class="viewcode-block" id="timing"><a class="viewcode-back" href="../../MDSLibraries.system_utility.html#MDSLibraries.pdb_structure.timing">[docs]</a><span class="k">def</span> <span class="nf">timing</span><span class="p">(</span><span class="n">f</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>

<span class="sd">    :param f:</span>
<span class="sd">    :type f:</span>
<span class="sd">    :return:</span>
<span class="sd">    :rtype:</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">def</span> <span class="nf">wrap</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">):</span>
        <span class="n">time1</span> <span class="o">=</span> <span class="n">time</span><span class="o">.</span><span class="n">time</span><span class="p">()</span>
        <span class="n">ret</span> <span class="o">=</span> <span class="n">f</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">)</span>
        <span class="n">time2</span> <span class="o">=</span> <span class="n">time</span><span class="o">.</span><span class="n">time</span><span class="p">()</span>
        <span class="c1"># if time2-time1&gt;=1:</span>
        <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;</span><span class="si">%s</span><span class="s1"> function took </span><span class="si">%0.3f</span><span class="s1"> s&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">f</span><span class="o">.</span><span class="vm">__name__</span><span class="p">,</span> <span class="p">(</span><span class="n">time2</span> <span class="o">-</span> <span class="n">time1</span><span class="p">)))</span>
        <span class="k">return</span> <span class="n">ret</span>

    <span class="k">return</span> <span class="n">wrap</span></div>

<div class="viewcode-block" id="profileit"><a class="viewcode-back" href="../../MDSLibraries.system_utility.html#MDSLibraries.pdb_structure.profileit">[docs]</a><span class="k">def</span> <span class="nf">profileit</span><span class="p">(</span><span class="n">func</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>

<span class="sd">    :param func:</span>
<span class="sd">    :type func:</span>
<span class="sd">    :return:</span>
<span class="sd">    :rtype:</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">def</span> <span class="nf">wrapper</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
        <span class="n">datafn</span> <span class="o">=</span> <span class="n">func</span><span class="o">.</span><span class="vm">__name__</span> <span class="o">+</span> <span class="s2">&quot;.profile&quot;</span>  <span class="c1"># Name the data file sensibly</span>
        <span class="n">prof</span> <span class="o">=</span> <span class="n">cProfile</span><span class="o">.</span><span class="n">Profile</span><span class="p">()</span>
        <span class="n">retval</span> <span class="o">=</span> <span class="n">prof</span><span class="o">.</span><span class="n">runcall</span><span class="p">(</span><span class="n">func</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>
        <span class="n">prof</span><span class="o">.</span><span class="n">dump_stats</span><span class="p">(</span><span class="n">datafn</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">retval</span>

    <span class="k">return</span> <span class="n">wrapper</span></div>

<div class="viewcode-block" id="safe_call"><a class="viewcode-back" href="../../MDSLibraries.system_utility.html#MDSLibraries.pdb_structure.safe_call">[docs]</a><span class="k">def</span> <span class="nf">safe_call</span><span class="p">(</span><span class="n">funct</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">funct</span><span class="p">(</span><span class="n">args</span><span class="p">,</span> <span class="n">kwargs</span><span class="p">)</span>
    <span class="k">except</span><span class="p">:</span>
        <span class="k">return</span> <span class="kc">None</span></div>

<div class="viewcode-block" id="explicit_checker"><a class="viewcode-back" href="../../MDSLibraries.system_utility.html#MDSLibraries.pdb_structure.explicit_checker">[docs]</a><span class="k">def</span> <span class="nf">explicit_checker</span><span class="p">(</span><span class="n">f</span><span class="p">):</span>
    <span class="n">varnames</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="vm">__code__</span><span class="o">.</span><span class="n">co_varnames</span>
    <span class="k">def</span> <span class="nf">wrapper</span><span class="p">(</span><span class="o">*</span><span class="n">a</span><span class="p">,</span> <span class="o">**</span><span class="n">kw</span><span class="p">):</span>
        <span class="n">kw</span><span class="p">[</span><span class="s1">&#39;explicit_params&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="nb">set</span><span class="p">(</span><span class="nb">list</span><span class="p">(</span><span class="n">varnames</span><span class="p">[:</span><span class="nb">len</span><span class="p">(</span><span class="n">a</span><span class="p">)])</span> <span class="o">+</span> <span class="nb">list</span><span class="p">(</span><span class="n">kw</span><span class="o">.</span><span class="n">keys</span><span class="p">()))</span>
        <span class="k">return</span> <span class="n">f</span><span class="p">(</span><span class="o">*</span><span class="n">a</span><span class="p">,</span> <span class="o">**</span><span class="n">kw</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">wrapper</span></div>

<span class="c1">#######################################################################################################</span>
<span class="c1">#                                                                                                     #</span>
<span class="c1">#######################################################################################################</span>

<span class="kn">import</span> <span class="nn">io</span>
<span class="kn">import</span> <span class="nn">locale</span>


<div class="viewcode-block" id="get_encoding"><a class="viewcode-back" href="../../MDSLibraries.system_utility.html#MDSLibraries.pdb_structure.get_encoding">[docs]</a><span class="k">def</span> <span class="nf">get_encoding</span><span class="p">():</span>
    <span class="k">return</span> <span class="s2">&quot;utf-8&quot;</span></div>
    <span class="c1">#return locale.getpreferredencoding()</span>

<div class="viewcode-block" id="guess_encoding"><a class="viewcode-back" href="../../MDSLibraries.system_utility.html#MDSLibraries.pdb_structure.guess_encoding">[docs]</a><span class="k">def</span> <span class="nf">guess_encoding</span><span class="p">(</span><span class="n">openfile</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;guess the encoding of the given file&quot;&quot;&quot;</span>
    <span class="kn">import</span> <span class="nn">io</span>
    <span class="kn">import</span> <span class="nn">locale</span>
    <span class="k">with</span> <span class="n">io</span><span class="o">.</span><span class="n">open</span><span class="p">(</span><span class="n">openfile</span><span class="p">,</span> <span class="s2">&quot;rb&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
        <span class="n">data</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="n">read</span><span class="p">(</span><span class="mi">5</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">data</span><span class="o">.</span><span class="n">startswith</span><span class="p">(</span><span class="sa">b</span><span class="s2">&quot;</span><span class="se">\xEF\xBB\xBF</span><span class="s2">&quot;</span><span class="p">):</span>  <span class="c1"># UTF-8 with a &quot;BOM&quot;</span>
        <span class="k">return</span> <span class="s2">&quot;utf-8-sig&quot;</span>
    <span class="k">elif</span> <span class="n">data</span><span class="o">.</span><span class="n">startswith</span><span class="p">(</span><span class="sa">b</span><span class="s2">&quot;</span><span class="se">\xFF\xFE</span><span class="s2">&quot;</span><span class="p">)</span> <span class="ow">or</span> <span class="n">data</span><span class="o">.</span><span class="n">startswith</span><span class="p">(</span><span class="sa">b</span><span class="s2">&quot;</span><span class="se">\xFE\xFF</span><span class="s2">&quot;</span><span class="p">):</span>
        <span class="k">return</span> <span class="s2">&quot;utf-16&quot;</span>
    <span class="k">else</span><span class="p">:</span>  <span class="c1"># in Windows, guessing utf-8 doesn&#39;t work, so we have to try</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="k">with</span> <span class="n">io</span><span class="o">.</span><span class="n">open</span><span class="p">(</span><span class="n">openfile</span><span class="p">,</span> <span class="n">encoding</span><span class="o">=</span><span class="s2">&quot;utf-8&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
                <span class="n">preview</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="n">read</span><span class="p">(</span><span class="mi">222222</span><span class="p">)</span>
                <span class="k">return</span> <span class="s2">&quot;utf-8&quot;</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="k">return</span> <span class="n">locale</span><span class="o">.</span><span class="n">getdefaultlocale</span><span class="p">()[</span><span class="mi">1</span><span class="p">]</span></div>


<span class="kn">import</span> <span class="nn">hashlib</span>
<span class="kn">from</span> <span class="nn">functools</span> <span class="kn">import</span> <span class="n">partial</span>

<div class="viewcode-block" id="md5sum"><a class="viewcode-back" href="../../MDSLibraries.system_utility.html#MDSLibraries.pdb_structure.md5sum">[docs]</a><span class="k">def</span> <span class="nf">md5sum</span><span class="p">(</span><span class="n">filename</span><span class="p">,</span> <span class="n">include_filename</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">filename</span><span class="p">,</span> <span class="n">mode</span><span class="o">=</span><span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
        <span class="n">d</span> <span class="o">=</span> <span class="n">hashlib</span><span class="o">.</span><span class="n">md5</span><span class="p">()</span>
        <span class="k">if</span> <span class="n">include_filename</span><span class="p">:</span> <span class="n">d</span><span class="o">.</span><span class="n">update</span><span class="p">(</span><span class="n">filename</span><span class="o">.</span><span class="n">encode</span><span class="p">(</span><span class="n">get_encoding</span><span class="p">()))</span>
        <span class="k">for</span> <span class="n">buf</span> <span class="ow">in</span> <span class="nb">iter</span><span class="p">(</span><span class="n">partial</span><span class="p">(</span><span class="n">f</span><span class="o">.</span><span class="n">read</span><span class="p">,</span> <span class="mi">128</span><span class="p">),</span> <span class="sa">b</span><span class="s1">&#39;&#39;</span><span class="p">):</span>
            <span class="n">d</span><span class="o">.</span><span class="n">update</span><span class="p">(</span><span class="n">buf</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">d</span><span class="o">.</span><span class="n">hexdigest</span><span class="p">()</span></div>

<div class="viewcode-block" id="special_request"><a class="viewcode-back" href="../../MDSLibraries.system_utility.html#MDSLibraries.pdb_structure.special_request">[docs]</a><span class="k">def</span> <span class="nf">special_request</span><span class="p">(</span><span class="n">search_string</span><span class="p">,</span> <span class="n">rootsite</span><span class="p">,</span> <span class="n">data</span><span class="p">,</span> <span class="n">topn</span><span class="o">=</span><span class="mi">10</span><span class="p">):</span>
    <span class="c1"># install a custom handler to prevent following of redirects automatically.</span>
    <span class="k">class</span> <span class="nc">SmartRedirectHandler</span><span class="p">(</span><span class="n">HTTPRedirectHandler</span><span class="p">):</span>
        <span class="k">def</span> <span class="nf">http_error_302</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">req</span><span class="p">,</span> <span class="n">fp</span><span class="p">,</span> <span class="n">code</span><span class="p">,</span> <span class="n">msg</span><span class="p">,</span> <span class="n">headers</span><span class="p">):</span>
            <span class="k">return</span> <span class="n">headers</span>

    <span class="n">opener</span> <span class="o">=</span> <span class="n">build_opener</span><span class="p">(</span><span class="n">SmartRedirectHandler</span><span class="p">())</span>
    <span class="n">install_opener</span><span class="p">(</span><span class="n">opener</span><span class="p">)</span>

    <span class="n">parameters</span> <span class="o">=</span> <span class="n">data</span>
    <span class="n">enc_params</span> <span class="o">=</span> <span class="n">urlencode</span><span class="p">(</span><span class="n">parameters</span><span class="p">)</span><span class="o">.</span><span class="n">encode</span><span class="p">(</span><span class="n">get_encoding</span><span class="p">())</span>

    <span class="c1"># post the seqrch request to the server</span>
    <span class="n">request</span> <span class="o">=</span> <span class="n">Request</span><span class="p">(</span><span class="s1">&#39;https://www.ebi.ac.uk/Tools/hmmer/search/phmmer&#39;</span><span class="p">,</span> <span class="n">enc_params</span><span class="p">)</span>

    <span class="c1"># get the url where the results can be fetched from</span>
    <span class="c1">#results_url = urlopen(request).getheader(&#39;location&#39;)</span>
    <span class="n">results_url</span> <span class="o">=</span> <span class="n">urlopen</span><span class="p">(</span><span class="n">request</span><span class="p">)[</span><span class="s2">&quot;location&quot;</span><span class="p">]</span>
    <span class="nb">print</span><span class="p">(</span><span class="n">results_url</span><span class="p">)</span>

    <span class="c1"># modify the range, format and presence of alignments in your results here</span>
    <span class="n">res_params</span> <span class="o">=</span> <span class="p">{</span>
        <span class="s1">&#39;output&#39;</span><span class="p">:</span> <span class="s1">&#39;json&#39;</span><span class="p">,</span>
        <span class="s1">&#39;range&#39;</span><span class="p">:</span> <span class="s1">&#39;1,&#39;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">topn</span><span class="p">)</span>
    <span class="p">}</span>

    <span class="c1"># add the parameters to your request for the results</span>
    <span class="n">enc_res_params</span> <span class="o">=</span> <span class="n">urlencode</span><span class="p">(</span><span class="n">res_params</span><span class="p">)</span><span class="o">.</span><span class="n">encode</span><span class="p">(</span><span class="n">get_encoding</span><span class="p">())</span>
    <span class="n">modified_res_url</span> <span class="o">=</span> <span class="n">results_url</span> <span class="o">+</span> <span class="p">(</span><span class="s1">&#39;?&#39;</span> <span class="o">+</span> <span class="n">enc_res_params</span><span class="p">)</span><span class="o">.</span><span class="n">decode</span><span class="p">(</span><span class="n">get_encoding</span><span class="p">())</span>

    <span class="c1"># send a GET request to the server</span>
    <span class="n">results_request</span> <span class="o">=</span> <span class="n">Request</span><span class="p">(</span><span class="n">modified_res_url</span><span class="p">)</span>
    <span class="n">data</span> <span class="o">=</span> <span class="n">urlopen</span><span class="p">(</span><span class="n">results_request</span><span class="p">)</span>

    <span class="c1"># print out the results</span>
    <span class="k">return</span> <span class="n">data</span><span class="o">.</span><span class="n">read</span><span class="p">()</span></div>

<div class="viewcode-block" id="download_url"><a class="viewcode-back" href="../../MDSLibraries.system_utility.html#MDSLibraries.pdb_structure.download_url">[docs]</a><span class="k">def</span> <span class="nf">download_url</span><span class="p">(</span><span class="n">url</span><span class="p">,</span> <span class="n">save_path</span><span class="p">,</span> <span class="n">chunk_size</span><span class="o">=</span><span class="mi">128</span><span class="p">):</span>
    <span class="n">r</span> <span class="o">=</span> <span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">url</span><span class="p">,</span> <span class="n">stream</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">save_path</span><span class="p">,</span> <span class="s1">&#39;wb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">fd</span><span class="p">:</span>
        <span class="k">for</span> <span class="n">chunk</span> <span class="ow">in</span> <span class="n">r</span><span class="o">.</span><span class="n">iter_content</span><span class="p">(</span><span class="n">chunk_size</span><span class="o">=</span><span class="n">chunk_size</span><span class="p">):</span>
            <span class="n">fd</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="n">chunk</span><span class="p">)</span></div>

<div class="viewcode-block" id="request_urlrequest"><a class="viewcode-back" href="../../MDSLibraries.system_utility.html#MDSLibraries.pdb_structure.request_urlrequest">[docs]</a><span class="k">def</span> <span class="nf">request_urlrequest</span><span class="p">(</span><span class="n">search_string</span><span class="p">,</span> <span class="n">rootsite</span><span class="p">,</span> <span class="n">method</span><span class="o">=</span><span class="s2">&quot;get&quot;</span><span class="p">,</span> <span class="n">data</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">files</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
    <span class="n">z</span> <span class="o">=</span> <span class="kc">None</span>
    <span class="n">tries</span> <span class="o">=</span> <span class="mi">10</span>
    <span class="k">for</span> <span class="n">trial</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">tries</span><span class="p">):</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">method</span> <span class="o">==</span> <span class="s2">&quot;get&quot;</span> <span class="ow">and</span> <span class="n">data</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                <span class="c1">#print(&quot;METHOD A GET:&quot;,search_string)</span>
                <span class="n">req</span> <span class="o">=</span> <span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">search_string</span><span class="p">,</span> <span class="n">files</span><span class="o">=</span><span class="p">{}</span> <span class="k">if</span> <span class="n">files</span> <span class="ow">is</span> <span class="kc">None</span> <span class="k">else</span> <span class="n">files</span><span class="p">,</span> <span class="n">timeout</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
                <span class="c1">#print(&quot;DONE&quot;)</span>
                <span class="k">try</span><span class="p">:</span>
                    <span class="n">z</span> <span class="o">=</span> <span class="n">req</span><span class="o">.</span><span class="n">json</span><span class="p">()</span>
                <span class="k">except</span><span class="p">:</span>
                    <span class="n">z</span> <span class="o">=</span> <span class="n">req</span>
            <span class="k">elif</span> <span class="n">method</span> <span class="o">==</span> <span class="s2">&quot;get&quot;</span><span class="p">:</span>
                <span class="c1">#print(&quot;METHOD B GET:&quot;,search_string)</span>
                <span class="n">req</span> <span class="o">=</span> <span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">search_string</span><span class="p">,</span> <span class="n">data</span><span class="p">,</span> <span class="n">files</span><span class="o">=</span><span class="p">{}</span> <span class="k">if</span> <span class="n">files</span> <span class="ow">is</span> <span class="kc">None</span> <span class="k">else</span> <span class="n">files</span><span class="p">,</span> <span class="n">timeout</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
                <span class="c1">#print(&quot;DONE&quot;)</span>
                <span class="k">try</span><span class="p">:</span>
                    <span class="n">z</span> <span class="o">=</span> <span class="n">req</span><span class="o">.</span><span class="n">json</span><span class="p">()</span>
                <span class="k">except</span><span class="p">:</span>
                    <span class="n">z</span> <span class="o">=</span> <span class="n">req</span>
            <span class="k">elif</span> <span class="n">method</span> <span class="o">==</span> <span class="s2">&quot;post&quot;</span><span class="p">:</span>
                <span class="c1"># print(&quot;METHOD C POST:&quot;,search_string)</span>
                <span class="c1"># print(requests)</span>
                <span class="c1"># print(requests.__file__)</span>
                <span class="n">req</span> <span class="o">=</span> <span class="n">requests</span><span class="o">.</span><span class="n">post</span><span class="p">(</span><span class="n">search_string</span><span class="p">,</span> <span class="n">data</span><span class="p">,</span> <span class="n">files</span><span class="o">=</span><span class="p">{}</span> <span class="k">if</span> <span class="n">files</span> <span class="ow">is</span> <span class="kc">None</span> <span class="k">else</span> <span class="n">files</span><span class="p">,</span> <span class="n">timeout</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
                <span class="c1"># print(&quot;DONE&quot;)</span>
                <span class="k">try</span><span class="p">:</span>
                    <span class="n">z</span> <span class="o">=</span> <span class="n">req</span><span class="o">.</span><span class="n">json</span><span class="p">()</span>
                <span class="k">except</span><span class="p">:</span>
                    <span class="n">z</span> <span class="o">=</span> <span class="n">req</span>
            <span class="k">break</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="nb">print</span><span class="p">(</span><span class="n">sys</span><span class="o">.</span><span class="n">exc_info</span><span class="p">())</span>
            <span class="c1">#traceback.print_exc(file=sys.stdout)</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Error contacting&quot;</span><span class="p">,</span><span class="n">rootsite</span><span class="p">,</span><span class="s2">&quot;...Attempt &quot;</span><span class="p">,</span> <span class="n">trial</span> <span class="o">+</span> <span class="mi">1</span><span class="p">,</span> <span class="s2">&quot;/&quot;</span><span class="p">,</span> <span class="n">tries</span><span class="p">,</span> <span class="n">search_string</span><span class="p">)</span>
            <span class="c1">#time.sleep(1)</span>
    <span class="k">if</span> <span class="ow">not</span> <span class="n">z</span><span class="p">:</span>
        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Connection Error&quot;</span><span class="p">)</span>
        <span class="k">return</span> <span class="kc">None</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">z</span></div>

<div class="viewcode-block" id="request_url"><a class="viewcode-back" href="../../MDSLibraries.system_utility.html#MDSLibraries.pdb_structure.request_url">[docs]</a><span class="k">def</span> <span class="nf">request_url</span><span class="p">(</span><span class="n">search_string</span><span class="p">,</span> <span class="n">rootsite</span><span class="p">,</span> <span class="n">data</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
    <span class="n">z</span> <span class="o">=</span> <span class="kc">None</span>
    <span class="n">tries</span> <span class="o">=</span> <span class="mi">10</span>
    <span class="k">for</span> <span class="n">trial</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">tries</span><span class="p">):</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">data</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                <span class="c1">#print(&quot;METHOD A&quot;, search_string, data)</span>
                <span class="n">req</span> <span class="o">=</span> <span class="n">Request</span><span class="p">(</span><span class="n">search_string</span><span class="p">)</span>
                <span class="n">z</span> <span class="o">=</span> <span class="n">urlopen</span><span class="p">(</span><span class="n">req</span><span class="p">)</span><span class="o">.</span><span class="n">read</span><span class="p">()</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="c1">#print(&quot;METHOD B&quot;, search_string, data)</span>
                <span class="n">req</span> <span class="o">=</span> <span class="n">Request</span><span class="p">(</span><span class="n">search_string</span><span class="p">)</span>
                <span class="n">z</span> <span class="o">=</span> <span class="n">urlopen</span><span class="p">(</span><span class="n">req</span><span class="p">,</span> <span class="n">data</span><span class="p">)</span><span class="o">.</span><span class="n">read</span><span class="p">()</span>
            <span class="k">break</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="nb">print</span><span class="p">(</span><span class="n">sys</span><span class="o">.</span><span class="n">exc_info</span><span class="p">())</span>
            <span class="n">traceback</span><span class="o">.</span><span class="n">print_exc</span><span class="p">(</span><span class="n">file</span><span class="o">=</span><span class="n">sys</span><span class="o">.</span><span class="n">stdout</span><span class="p">)</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Error contacting&quot;</span><span class="p">,</span><span class="n">rootsite</span><span class="p">,</span><span class="s2">&quot;...Attempt &quot;</span><span class="p">,</span> <span class="n">trial</span> <span class="o">+</span> <span class="mi">1</span><span class="p">,</span> <span class="s2">&quot;/&quot;</span><span class="p">,</span> <span class="n">tries</span><span class="p">,</span> <span class="n">search_string</span><span class="p">)</span>
            <span class="c1">#time.sleep(1)</span>
    <span class="k">if</span> <span class="ow">not</span> <span class="n">z</span><span class="p">:</span>
        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Connection Error&quot;</span><span class="p">)</span>
        <span class="k">return</span> <span class="kc">None</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">z</span></div>

<div class="viewcode-block" id="warning"><a class="viewcode-back" href="../../MDSLibraries.system_utility.html#MDSLibraries.pdb_structure.warning">[docs]</a><span class="k">def</span> <span class="nf">warning</span><span class="p">(</span><span class="n">objs</span><span class="p">):</span>
    <span class="n">sys</span><span class="o">.</span><span class="n">stderr</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="s2">&quot;WARNING: &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">objs</span><span class="p">)</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span><span class="p">)</span></div>

<div class="viewcode-block" id="findInSubdirectory"><a class="viewcode-back" href="../../MDSLibraries.system_utility.html#MDSLibraries.pdb_structure.findInSubdirectory">[docs]</a><span class="k">def</span> <span class="nf">findInSubdirectory</span><span class="p">(</span><span class="n">filename</span><span class="p">,</span> <span class="n">subdirectory</span><span class="o">=</span><span class="s1">&#39;&#39;</span><span class="p">):</span>
    <span class="k">if</span> <span class="n">subdirectory</span><span class="p">:</span>
        <span class="n">path</span> <span class="o">=</span> <span class="n">subdirectory</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">getcwd</span><span class="p">()</span>
    <span class="k">for</span> <span class="n">root</span><span class="p">,</span> <span class="n">subFolders</span><span class="p">,</span> <span class="n">files</span> <span class="ow">in</span> <span class="n">os</span><span class="o">.</span><span class="n">walk</span><span class="p">(</span><span class="n">path</span><span class="p">):</span>
        <span class="k">for</span> <span class="n">fileu</span> <span class="ow">in</span> <span class="n">files</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">fileu</span> <span class="o">==</span> <span class="n">filename</span><span class="p">:</span>
                <span class="k">return</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">root</span><span class="p">,</span> <span class="n">fileu</span><span class="p">)</span>
    <span class="k">raise</span> <span class="ne">Exception</span><span class="p">()</span></div>

<div class="viewcode-block" id="mem"><a class="viewcode-back" href="../../MDSLibraries.system_utility.html#MDSLibraries.pdb_structure.mem">[docs]</a><span class="k">def</span> <span class="nf">mem</span><span class="p">(</span><span class="n">size</span><span class="o">=</span><span class="s2">&quot;rss&quot;</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Generalization; memory sizes: rss, rsz, vsz.&quot;&quot;&quot;</span>
    <span class="k">return</span> <span class="nb">int</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">popen</span><span class="p">(</span><span class="s1">&#39;ps -p </span><span class="si">%d</span><span class="s1"> -o </span><span class="si">%s</span><span class="s1"> | tail -1&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">getpid</span><span class="p">(),</span> <span class="n">size</span><span class="p">))</span><span class="o">.</span><span class="n">read</span><span class="p">())</span></div>

<div class="viewcode-block" id="rss"><a class="viewcode-back" href="../../MDSLibraries.system_utility.html#MDSLibraries.pdb_structure.rss">[docs]</a><span class="k">def</span> <span class="nf">rss</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot;Return ps -o rss (resident) memory in kB.&quot;&quot;&quot;</span>
    <span class="k">return</span> <span class="n">mem</span><span class="p">(</span><span class="s2">&quot;rss&quot;</span><span class="p">)</span></div>

<div class="viewcode-block" id="rsz"><a class="viewcode-back" href="../../MDSLibraries.system_utility.html#MDSLibraries.pdb_structure.rsz">[docs]</a><span class="k">def</span> <span class="nf">rsz</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot;Return ps -o rsz (resident + text) memory in kB.&quot;&quot;&quot;</span>
    <span class="k">return</span> <span class="n">mem</span><span class="p">(</span><span class="s2">&quot;rsz&quot;</span><span class="p">)</span></div>

<div class="viewcode-block" id="vsz"><a class="viewcode-back" href="../../MDSLibraries.system_utility.html#MDSLibraries.pdb_structure.vsz">[docs]</a><span class="k">def</span> <span class="nf">vsz</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot;Return ps -o vsz (virtual) memory in kB.&quot;&quot;&quot;</span>
    <span class="k">return</span> <span class="n">mem</span><span class="p">(</span><span class="s2">&quot;vsz&quot;</span><span class="p">)</span></div>

<div class="viewcode-block" id="find_free_port"><a class="viewcode-back" href="../../MDSLibraries.system_utility.html#MDSLibraries.pdb_structure.find_free_port">[docs]</a><span class="k">def</span> <span class="nf">find_free_port</span><span class="p">():</span>
    <span class="n">s</span> <span class="o">=</span> <span class="n">socket</span><span class="o">.</span><span class="n">socket</span><span class="p">()</span>
    <span class="n">s</span><span class="o">.</span><span class="n">bind</span><span class="p">((</span><span class="s1">&#39;&#39;</span><span class="p">,</span> <span class="mi">0</span><span class="p">))</span>      <span class="c1"># Bind to a free port provided by the host.</span>
    <span class="n">port</span> <span class="o">=</span> <span class="n">s</span><span class="o">.</span><span class="n">getsockname</span><span class="p">()[</span><span class="mi">1</span><span class="p">]</span>
    <span class="n">s</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
    <span class="k">return</span> <span class="n">port</span></div>

<span class="c1"># TODO: Managing Threads should be always in synchro. the main thread should have the possibility to know</span>
<span class="c1"># when a thread child has died, finished or exit and take decisions by consequence.</span>

<div class="viewcode-block" id="OutputThreading"><a class="viewcode-back" href="../../MDSLibraries.system_utility.html#MDSLibraries.pdb_structure.OutputThreading">[docs]</a><span class="k">class</span> <span class="nc">OutputThreading</span><span class="p">(</span><span class="n">threading</span><span class="o">.</span><span class="n">Thread</span><span class="p">):</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">externalCallable</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">):</span>
        <span class="n">threading</span><span class="o">.</span><span class="n">Thread</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">externalCallable</span> <span class="o">=</span> <span class="n">externalCallable</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">args</span> <span class="o">=</span> <span class="n">args</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">kwds</span> <span class="o">=</span> <span class="n">kwds</span>

<div class="viewcode-block" id="OutputThreading.run"><a class="viewcode-back" href="../../MDSLibraries.system_utility.html#MDSLibraries.pdb_structure.OutputThreading.run">[docs]</a>    <span class="k">def</span> <span class="nf">run</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="n">ar</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">args</span>
        <span class="n">kw</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">kwds</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">externalCallable</span><span class="p">(</span><span class="o">*</span><span class="n">ar</span><span class="p">,</span> <span class="o">**</span><span class="n">kw</span><span class="p">)</span></div>

    <span class="k">def</span> <span class="nf">_get_my_tid</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;determines this (self&#39;s) thread id</span>

<span class="sd">        CAREFUL : this function is executed in the context of the caller</span>
<span class="sd">        thread, to get the identity of the thread represented by this</span>
<span class="sd">        instance.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="bp">self</span><span class="o">.</span><span class="n">isAlive</span><span class="p">():</span>
            <span class="k">raise</span> <span class="n">threading</span><span class="o">.</span><span class="n">ThreadError</span><span class="p">(</span><span class="s2">&quot;the thread is not active&quot;</span><span class="p">)</span>

        <span class="c1"># do we have it cached?</span>
        <span class="k">if</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s2">&quot;_thread_id&quot;</span><span class="p">):</span>
            <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_thread_id</span>

        <span class="c1"># no, look for it in the _active dict</span>
        <span class="k">for</span> <span class="n">tid</span><span class="p">,</span> <span class="n">tobj</span> <span class="ow">in</span> <span class="n">threading</span><span class="o">.</span><span class="n">_active</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="k">if</span> <span class="n">tobj</span> <span class="ow">is</span> <span class="bp">self</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">_thread_id</span> <span class="o">=</span> <span class="n">tid</span>
                <span class="k">return</span> <span class="n">tid</span>

        <span class="c1"># TODO: in python 2.6, there&#39;s a simpler way to do : self.ident</span>

        <span class="k">raise</span> <span class="ne">AssertionError</span><span class="p">(</span><span class="s2">&quot;could not determine the thread&#39;s id&quot;</span><span class="p">)</span>

<div class="viewcode-block" id="OutputThreading.raiseExc"><a class="viewcode-back" href="../../MDSLibraries.system_utility.html#MDSLibraries.pdb_structure.OutputThreading.raiseExc">[docs]</a>    <span class="k">def</span> <span class="nf">raiseExc</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">exctype</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Raises the given exception type in the context of this thread.</span>

<span class="sd">        If the thread is busy in a system call (time.sleep(),</span>
<span class="sd">        socket.accept(), ...), the exception is simply ignored.</span>

<span class="sd">        If you are sure that your exception should terminate the thread,</span>
<span class="sd">        one way to ensure that it works is:</span>

<span class="sd">            t = ThreadWithExc( ... )</span>
<span class="sd">            ...</span>
<span class="sd">            t.raiseExc( SomeException )</span>
<span class="sd">            while t.isAlive():</span>
<span class="sd">                time.sleep( 0.1 )</span>
<span class="sd">                t.raiseExc( SomeException )</span>

<span class="sd">        If the exception is to be caught by the thread, you need a way to</span>
<span class="sd">        check that your thread has caught it.</span>

<span class="sd">        CAREFUL : this function is executed in the context of the</span>
<span class="sd">        caller thread, to raise an excpetion in the context of the</span>
<span class="sd">        thread represented by this instance.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">_async_raise</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">_get_my_tid</span><span class="p">(),</span> <span class="n">exctype</span><span class="p">)</span></div></div>


<span class="k">def</span> <span class="nf">_async_raise</span><span class="p">(</span><span class="n">tid</span><span class="p">,</span> <span class="n">exctype</span><span class="p">):</span>
    <span class="sd">&#39;&#39;&#39;Raises an exception in the threads with id tid&#39;&#39;&#39;</span>
    <span class="k">if</span> <span class="ow">not</span> <span class="n">inspect</span><span class="o">.</span><span class="n">isclass</span><span class="p">(</span><span class="n">exctype</span><span class="p">):</span>
        <span class="k">raise</span> <span class="ne">TypeError</span><span class="p">(</span><span class="s2">&quot;Only types can be raised (not instances)&quot;</span><span class="p">)</span>
    <span class="n">res</span> <span class="o">=</span> <span class="n">ctypes</span><span class="o">.</span><span class="n">pythonapi</span><span class="o">.</span><span class="n">PyThreadState_SetAsyncExc</span><span class="p">(</span><span class="n">ctypes</span><span class="o">.</span><span class="n">c_long</span><span class="p">(</span><span class="n">tid</span><span class="p">),</span>
                                                     <span class="n">ctypes</span><span class="o">.</span><span class="n">py_object</span><span class="p">(</span><span class="n">exctype</span><span class="p">))</span>
    <span class="k">if</span> <span class="n">res</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
        <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span><span class="s2">&quot;invalid thread id&quot;</span><span class="p">)</span>
    <span class="k">elif</span> <span class="n">res</span> <span class="o">!=</span> <span class="mi">1</span><span class="p">:</span>
        <span class="c1"># &quot;if it returns a number greater than one, you&#39;re in trouble,</span>
        <span class="c1"># and you should call it again with exc=NULL to revert the effect&quot;</span>
        <span class="n">ctypes</span><span class="o">.</span><span class="n">pythonapi</span><span class="o">.</span><span class="n">PyThreadState_SetAsyncExc</span><span class="p">(</span><span class="n">ctypes</span><span class="o">.</span><span class="n">c_long</span><span class="p">(</span><span class="n">tid</span><span class="p">),</span> <span class="kc">None</span><span class="p">)</span>
        <span class="k">raise</span> <span class="ne">SystemError</span><span class="p">(</span><span class="s2">&quot;PyThreadState_SetAsyncExc failed&quot;</span><span class="p">)</span>

<div class="viewcode-block" id="signal_term_handler"><a class="viewcode-back" href="../../MDSLibraries.system_utility.html#MDSLibraries.pdb_structure.signal_term_handler">[docs]</a><span class="k">def</span> <span class="nf">signal_term_handler</span><span class="p">(</span><span class="n">signal</span><span class="p">,</span><span class="n">frame</span><span class="p">):</span>
    <span class="nb">print</span> <span class="p">(</span><span class="s1">&#39;</span><span class="se">\n</span><span class="s1">The program received a signal of termination&#39;</span><span class="p">)</span>
    <span class="k">if</span> <span class="nb">hasattr</span><span class="p">(</span><span class="n">sys</span><span class="p">,</span> <span class="s1">&#39;_MEIPASS&#39;</span><span class="p">):</span>
        <span class="nb">print</span> <span class="p">(</span><span class="s2">&quot;Temp file was &quot;</span><span class="p">,</span> <span class="n">sys</span><span class="o">.</span><span class="n">_MEIPASS</span><span class="p">,</span> <span class="s2">&quot; and was removed before exiting&quot;</span><span class="p">)</span>
    <span class="n">sys</span><span class="o">.</span><span class="n">exit</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span></div>

<div class="viewcode-block" id="get_number_of_cpus"><a class="viewcode-back" href="../../MDSLibraries.system_utility.html#MDSLibraries.pdb_structure.get_number_of_cpus">[docs]</a><span class="k">def</span> <span class="nf">get_number_of_cpus</span><span class="p">():</span>
    <span class="k">return</span> <span class="n">multiprocessing</span><span class="o">.</span><span class="n">cpu_count</span><span class="p">()</span></div>

<div class="viewcode-block" id="spawn_function_with_multiprocessing"><a class="viewcode-back" href="../../MDSLibraries.system_utility.html#MDSLibraries.pdb_structure.spawn_function_with_multiprocessing">[docs]</a><span class="k">def</span> <span class="nf">spawn_function_with_multiprocessing</span><span class="p">(</span><span class="n">target</span><span class="p">,</span> <span class="n">args</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">kwargs</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">name</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">blocking</span><span class="o">=</span><span class="kc">True</span><span class="p">):</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">multiprocessing</span><span class="o">.</span><span class="n">cpu_count</span><span class="p">()</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
                <span class="k">while</span> <span class="mi">1</span><span class="p">:</span>
                    <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">multiprocessing</span><span class="o">.</span><span class="n">active_children</span><span class="p">())</span> <span class="o">&lt;</span> <span class="n">multiprocessing</span><span class="o">.</span><span class="n">cpu_count</span><span class="p">():</span>
                        <span class="n">p2</span> <span class="o">=</span> <span class="n">multiprocessing</span><span class="o">.</span><span class="n">Process</span><span class="p">(</span><span class="n">name</span><span class="o">=</span><span class="n">target</span><span class="o">.</span><span class="vm">__name__</span>  <span class="k">if</span> <span class="n">name</span> <span class="ow">is</span> <span class="kc">None</span> <span class="k">else</span> <span class="n">name</span><span class="p">,</span> <span class="n">target</span><span class="o">=</span><span class="n">target</span><span class="p">,</span> <span class="n">args</span><span class="o">=</span><span class="n">args</span> <span class="k">if</span> <span class="n">args</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="k">else</span> <span class="p">[],</span> <span class="n">kwargs</span><span class="o">=</span><span class="n">kwargs</span> <span class="k">if</span> <span class="n">kwargs</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="k">else</span> <span class="p">{})</span>
                        <span class="n">p2</span><span class="o">.</span><span class="n">start</span><span class="p">()</span>
                        <span class="k">return</span> <span class="n">p2</span>
                    <span class="k">if</span> <span class="ow">not</span> <span class="n">blocking</span><span class="p">:</span> <span class="k">return</span> <span class="kc">False</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;FATAL ERROR: I cannot load correctly information of CPUs.&quot;</span><span class="p">)</span>
                <span class="n">sys</span><span class="o">.</span><span class="n">exit</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span>
        <span class="k">except</span> <span class="ne">KeyboardInterrupt</span><span class="p">:</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;The user requires to exit from the program.&quot;</span><span class="p">)</span>
            <span class="n">sys</span><span class="o">.</span><span class="n">exit</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span></div>

<div class="viewcode-block" id="py2_3_unicode"><a class="viewcode-back" href="../../MDSLibraries.system_utility.html#MDSLibraries.pdb_structure.py2_3_unicode">[docs]</a><span class="k">def</span> <span class="nf">py2_3_unicode</span><span class="p">(</span><span class="n">value</span><span class="p">):</span>
    <span class="k">global</span> <span class="n">PYTHON_V</span>

    <span class="k">if</span> <span class="n">PYTHON_V</span> <span class="o">==</span> <span class="mi">2</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">unicode</span><span class="p">(</span><span class="n">value</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">value</span></div>

<div class="viewcode-block" id="py2_3_str"><a class="viewcode-back" href="../../MDSLibraries.system_utility.html#MDSLibraries.pdb_structure.py2_3_str">[docs]</a><span class="k">def</span> <span class="nf">py2_3_str</span><span class="p">(</span><span class="n">value</span><span class="p">):</span>
    <span class="k">global</span> <span class="n">PYTHON_V</span>

    <span class="k">if</span> <span class="n">PYTHON_V</span> <span class="o">==</span> <span class="mi">2</span><span class="p">:</span>
        <span class="k">return</span> <span class="nb">str</span><span class="p">(</span><span class="n">value</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">value</span></div>

<div class="viewcode-block" id="py2_3_bytes"><a class="viewcode-back" href="../../MDSLibraries.system_utility.html#MDSLibraries.pdb_structure.py2_3_bytes">[docs]</a><span class="k">def</span> <span class="nf">py2_3_bytes</span><span class="p">(</span><span class="n">value</span><span class="p">):</span>
    <span class="k">global</span> <span class="n">PYTHON_V</span>

    <span class="k">if</span> <span class="n">PYTHON_V</span> <span class="o">==</span> <span class="mi">2</span><span class="p">:</span>
        <span class="k">return</span> <span class="nb">bytes</span><span class="p">(</span><span class="n">value</span><span class="p">)</span><span class="o">.</span><span class="n">encode</span><span class="p">(</span><span class="sa">u</span><span class="s1">&#39;utf_8&#39;</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">value</span></div>
</pre></div>

          </div>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../index.html" >Module code</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2020, Massimo D. Sammito.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.8.5.
    </div>
  </body>
</html>